;################################################################################
;###################### LISTVIEW-TYPE ###########################################
;################################################################################

Type LastClick
	Field LLine
	Field LHandle
	Field LColumn
	Field LX,LY
	Field LTyp
	Field LWidth
	Field LHeight
	Field LFontHandle
	Field LTextA
	Field LText$
End Type
Global LastC.LastClick
LastC.LastClick = New LastClick


;################################################################################
;###################### HAUPTFUNKTIONEN #########################################
;################################################################################


Function LV_Register(k)												
	UF__Register(k)
End Function

Function LV_CreateListview(w,s=$0,tc=-1,hc=$D8E9EC,hc2=-1)			
	Return UF__CreateListview(QueryObject(w,1),0,tc,hc,hc2,s)
End Function 

Function LV_AddColumn(h,t$,w,s=0,tz$="#")							
	For x = 0 To Len(t)
		z$ = Mid(t,x,1)
		If z$ <> tz Then s2$ = s2$ + z
		If z = tz Or x = Len(t) Then
			UF__IColumn(h,s2,w,s)
			s2 = ""
		End If 
	Next
End Function 

Function LV_AddItem(o,s$,i=-2,w=-1,tz$="#")							
	UF__SetIconColumn(0)
	UF__SetIndex(w)
	Local b[63]
	For x = 1 To Len(s)
		z$ = Mid(s,x,1)
		If z$ <> tz Then s2$ = s2$ + z
		If z = tz Or x = Len(s) Then
			b[n] = CreateBank(Len(s2)+1)
			PokeString(s2,b[n])
			n = n + 1
			s2 = ""
		End If 
	Next
	b2 = CreateBank((n)*4)
	For x = 0 To N-1
		PokeInt b2,x*4,ptr_helper__(b[x],1,1)
	Next
	UF__SItem o,b2,n-1
	If w = -1 Then w = UF__GetLines(o)-1
	UF__SetIcon o,w,i
	FreeBank b2
	For x = 0 To N-1
		FreeBank b[x]
	Next
End Function 

Function LV_ShowListview(o,x,y,w,h)									
	UF__ShowListview o,x,y,w,h
End Function 

Function LV_InitMessages(w)											
	UF__InitMessages(QueryObject(w,1))
End Function 

Function LV_CloseMessages(w)										
	UF__CloseMessages(QueryObject(w,1))
End Function

Function LV_SortOptions(h,t$,i=-1)									
	If i=-1 Then
		b = CreateBank(Len(t)*4)
		For x = 1 To Len(t)
			z = Mid(t,x,1)
			If z > 2 Then z = 0
			PokeInt b,x*4-4,z
		Next
		UF__ASortListview(h,b,Len(t))
		FreeBank b
	End If
	If i > -1 Then
		UF__SetColumnSort(h,i,Int(t))
	End If 
End Function 

Function LV_RaiseColumns(h,t$,tc=-1,hc=-1)							
	b1 = CreateBank(64)
	For x = 1 To Len(t)
		PokeByte b1,x-1,Mid(t,x,1)
	Next
	UF__RaiseColumns(h,b1,tc,hc)
	FreeBank b1
End Function

Function LV_RaiseLine(h,l,tc=-1,hc=-1)								
	UF__RaiseLine(h,l,tc,hc)
End Function

Function LV_SetImage(h,t$,f=1)										
	b1 = CreateBank(Len(t)+1)
	PokeString(t,b1)
	UF__SetBackImage(h,b1,f)
	FreeBank b1
End Function 

Function LV_PrintListview(W,h,U$,SZ$,F,C$="",SH=56,SL=200,SR=200,SO=200,SU=200,PS=16,PZ=16)
	If c <> "" Then
		b1 = CreateBank(64)
		For x = 1 To Len(c)
			If x = 65 Then Exit 
			PokeByte b1,x-1,Int(Mid(c,x,1))
		Next
		UF__PrintColumns(b1)
		FreeBank b1
	End If 
	b1 = CreateBank(Len(U )+1):PokeString(U ,b1)
	b2 = CreateBank(Len(SZ)+1):PokeString(SZ,b2)
	UF__PrintListview(h,QueryObject(W,1),0,SH,SL,SO,SR,SU,PS,PZ,b1,b2,F)
	FreeBank b2
	FreeBank b1
End Function 


Function LV_EraseListview(h)										
	UF__EraseListview(h)
End Function 


Function LV_LoadFilelist(h,p$,f,f2$="",m=0)							
	;Filter setzten
	If f2 <> "" Then 
		f2 = Replace("."+f2,",",Chr(124)+".")
		;f2=Left(f2,Len(f2))
		b1 = CreateBank(Len(f2)+1):PokeString(f2,b1)
		If m=0 Then UF__SetFilelistNoFilter(b1)
		If m=1 Then UF__SetFilelistFilter(b1)
		FreeBank b1
	End If 
	;Datei laden
	b1 = CreateBank(Len(p)+1):PokeString(p,b1)
	b2 = CreateBank(200000)
	b3 = CreateBank(4)
	b5 = CreateBank(4)
	b4 = CreateBank(40000)
	g = UF__FilelistToCsv(b1,b2,b5,b3,f,b4)
	;Columns setzen
	If getFlag($100,f) = 0 Then 
		s = UF__SetColumnsFromMem(h,b2,b3)
		o = PeekInt(b3,0)
	End If
	;in Listview laden
	UF__CsvToListview2(h,(ptr_helper__(b2,1,1)+o),(g-o),s)
	;Icons
	If Getflag($10,f) Then 
		l = UF__GetLines(h)
		UF__SetIconsFromMem(h,0,b4,l)
	End If
	;Banks lschen
	FreeBank b1
	FreeBank b2
	FreeBank b3
	FreeBank b4
End Function


Function LV_LoadCSVFile(h,f$,p$="",s2$="")							
	If FileType(f) = 0 Or FileType(f) = 2 Then Return
	s = FileSize(f)
	b1 = CreateBank(Len(f)+2)
	PokeString(f,b1)
	b2 = CreateBank(s)
	UF__ReadFileQuick(b1,b2,0,s)

	If p<>"" Then
		b3 = CreateBank(Len(p)+1)
		PokeString(p,b3)
		UF__CryptMem(b2,s,b3,Len(p))
		FreeBank b3		
	End If
	
	If s2 <> "" Then
		UF__ExchangeSeparator(b2,s,Asc(s2),Asc(";"))
	End If
	
	UF__CsvToListview(h,b2,s,UF__GetColumns(h))
	FreeBank b1:FreeBank b2
End Function 

Function LV_SaveCSVFile(h,f$,p$="",s$="")							
	b1 = CreateBank(UF__GetNeededMemory(h,1))
	UF__ListviewToCsv(h,b1,Asc(s),0)
	
	If p<>"" Then
		b2 = CreateBank(Len(p)+1)
		PokeString(p,b2)
		UF__CryptMem(b1,UF__GetNeededMemory(h,1),b2,Len(p))
		FreeBank b2		
	End If
	
	b2 = CreateBank(Len(f)+1)
	PokeString(f,b2)
	UF__WriteFileQuick(b2,b1,0,UF__GetNeededMemory(h,1))
	FreeBank b1:FreeBank b2
End Function 


Function LV_LoadDBFFile(h,f$,p$="")									
	If FileType(f) = 0 Or FileType(f) = 2 Then Return
	s = FileSize(f)
	b1 = CreateBank(Len(f)+2)
	PokeString(f,b1)
	b2 = CreateBank(s)
	UF__ReadFileQuick(b1,b2,0,s)

	If p<>"" Then
		b3 = CreateBank(Len(p)+1)
		PokeString(p,b3)
		UF__CryptMem(b2,s,b3,Len(p))
		FreeBank b3		
	End If
	
	b3 = CreateBank(4)
	x = UF__DbfToCsv(b2,s,b3,b3,3)
	UF__CsvToListview(h,b2,x,UF__GetColumns(h))
	FreeBank b1:FreeBank b2:FreeBank b3
End Function 

Function LV_SaveDBFFile(h,f$,p$="")									
	b1 = CreateBank(UF__GetNeededMemory(h,2))
	UF__ListviewToDbf(h,b1,UF__GetNeededMemory(h,2),0)

	If p<>"" Then
		b2 = CreateBank(Len(p)+1)
		PokeString(p,b2)
		UF__CryptMem(b1,UF__GetNeededMemory(h,2),b2,Len(p))
		FreeBank b2		
	End If
	
	b2 = CreateBank(Len(f)+1)
	PokeString(f,b2)
	UF__WriteFileQuick(b2,b1,0,UF__GetNeededMemory(h,2))
	FreeBank b1:FreeBank b2
End Function 


Function LV_CreateImageList(h,F)									
	b = CreateBank(4)
	x = UF__CreateImageList(F,b)
	y = PeekInt(b,0)
	UF__SetImageList(h,x)
	FreeBank p
	Return y
End Function 

Function LV_SetIcon(h,i,y$,c=0,w=0,m=0)								
	UF__SetIconMode m
	UF__SetIconColumn(c)
	If w > 0 Then
		UF__SetIconsWith(h,i,Int(y),w)
		Return
	End If 
	b = CreateBank(4)
	For x = 1 To Len(y)
		z$ = Mid(y,x,1)
		If z$ <> "," Then s2$ = s2$ + z
		If z = "," Or x = Len(y) Then
			ResizeBank b,n*4+4
			PokeInt b,n*4,Int(s2)
			n = n + 1
			s2 = ""
		End If 
	Next
	UF__SetIconsFromMem(h,i,b,n)
	FreeBank b
End Function


Function LV_Search(h,st$,f=0,z1=0,z2=-2,s=0)						
	b1 = CreateBank(Len(st)+1)
	Pokestring(st,b1)
	b2 = CreateBank(4)
	If z2 = -2 Then z2 = UF__GetLines(h)
	z = UF__SearchText(h,z1,z2,s,b1,f,b2)
	s = PeekInt(b2,0)
	FreeBank b1:FreeBank B2
	If z = -1 Then Return 0
	LastC\LY = z:LastC\LX = s
	Return 1
End Function


Function LV_EnableEdits(h,i=1)										
	UF__EnableEdits(h,i)
End Function 

Function LV_ColumnEdits(h,s$)										
	b = CreateBank(64)
	For x = 1 To Len(s)
		PokeByte b,x-1,Int(Mid(s,x,1))
	Next
	UF__SelectColumnEdits h,b
	FreeBank b
End Function 


Function LV_SaveListviewStyle(h,t$)									
	b1 = CreateBank(768)
	UF__GetColumnUpdate(h,b1)
	b2 = CreateBank(Len(t)+1)
	PokeString(t,b2)
	UF__WriteFileQuick(b2,b1,0,768)
	FreeBank b1
	FreeBank b2
End Function

Function LV_LoadListviewStyle(h,t$)									
	b1 = CreateBank(768)
	b2 = CreateBank(Len(t)+1)
	PokeString(t,b2)
	UF__ReadFileQuick(b2,b1,0,768)
	UF__SetColumnUpdate(h,b1)
	FreeBank b1
	FreeBank b2
End Function


Function LV_GetColumns(h)											
	Return UF__GetColumns(h)
End Function

Function LV_GetLines(h)												
	Return UF__GetLines(h)
End Function

Function LV_GetSelected(m=0)										
	b1 = CreateBank(16384)
	b2 = CreateBank(4)
	If m=0 Then 
		y = UF__GetSelected(b1,b2)
		i = PeekInt(b2,0)
		FreeBank b1:FreeBank b2
		If y Then Return i
	End If
	If m=1 Then
		y = UF__GetSelectedDbClk(b1,b2)
		i = PeekInt(b2,0)
		FreeBank b1:FreeBank b2
		If y Then Return i
	End If
	If m=2 Then
		y = UF__GetAllSelected(b1,b2)
		FreeBank b1:FreeBank b2
		Return y
	End If
	If m=3 Then
		y = UF__GetAllSelected(b1,b2)
		i = PeekInt(b2,0)
		FreeBank b1:FreeBank b2
		If y Then Return i
	End If 
	FreeBank b1:FreeBank b2
End Function 

Function LV_GetSelectedLine(h)										
	Return UF__GetSelectedLine(h)
End Function

Function LV_GetColumnWidth(h,c)										
	Return UF__GetColumnWidth(h,c)
End Function 

Function LV_GetLineText$(h,l,c=-1)									
	b1 = CreateBank(16384)
	If C = -1 Then
		UF__GetLineText(h,l,b1)
		For x = 0 To 16383
			t$ = t + Chr(PeekByte(b1,x))
			If PeekByte(b1,x)=0 Then Exit
		Next
		FreeBank b1
		Return t
	End If

	If c > -1 Then
		b2 = CreateBank(256)
		UF__GetLineText(h,l,b1)
		UF__GetTabOffsets(b1,b2)
		For x = PeekInt(b2,c*4) To 16384
			If PeekByte(b1,x) = 0 Then Exit
			t$ = t + Chr(PeekByte(b1,x))
		Next
		FreeBank b1
		FreeBank b2
		Return t
	End If
	FreeBank b1
End Function

Function LV_GetChecked(f=1)											
	b1=CreateBank(4)
	b2=CreateBank(4)
	b3=CreateBank(4)
	i = UF__GetChecked(b1,b2,b3)
	w1=PeekInt(b1,0):FreeBank b1
	w2=PeekInt(b2,0):FreeBank b2
	w3=PeekInt(b3,0):FreeBank b3
	If i = 1 Then
		If f=0 Then Return w1
		If f=1 Then Return w2
		If f=2 Then Return w3
		If f=4 Then Return (w2*$10000)+w3
	End If
	Return -1
End Function

Function LV_GetCheckboxState(h,l)									
	Return UF__GetCheckboxState(h,l)
End Function

Function LV_GetItemText$(h,l,c)
	b1 = CreateBank(256)
	UF__GetItemText(h,b1,c,l)
	For x = 0 To 255
		If PeekByte(b1,x) = 0 Then Exit
		t$=t+Chr(PeekByte(b1,x))
	Next
	Return t
End Function

Function LV_GetColumnFormat(h,c)									
	Return UF__ExamineColumn(h,c)
End Function 

Function LV_GetLastClick()											
	b1 = CreateBank(320)
	i = UF__GetControlParas(b1)
	If i=0 Then FreeBank b1:Return 0
	LastC\LTyp    = i
	LastC\LHandle = PeekInt(b1,0)
	LastC\Lcolumn = PeekInt(b1,4)
	LastC\Lline   = PeekInt(b1,8)
	LastC\LX      = PeekInt(b1,12)
	LastC\LY      = PeekInt(b1,16)
	LastC\LWidth  = PeekInt(b1,20)
	LastC\LHeight = PeekInt(b1,24)
	LastC\LFontHandle = PeekInt(b1,28)
	LastC\LTextA = PeekInt(b1,32)
	LastC\LHandle = PeekInt(b1,0)
	LastC\LText = ""
	For x = 64 To 319
		If PeekByte(b1,x)=0 Then Exit
		LastC\LText = LastC\LText + Chr(PeekByte(b1,x))
	Next
	FreeBank b1
	Return LastC\LHandle
End Function

Function LV_GetItemDatas(h,l,c)										
	b1 = CreateBank(320)
	UF__GetOwnControlParas(b1,h,c,l)
	LastC\LHandle = PeekInt(b1,0)
	LastC\Lcolumn = PeekInt(b1,4)
	LastC\Lline   = PeekInt(b1,8)
	LastC\LX      = PeekInt(b1,12)
	LastC\LY      = PeekInt(b1,16)
	LastC\LWidth  = PeekInt(b1,20)
	LastC\LHeight = PeekInt(b1,24)
	LastC\LFontHandle = PeekInt(b1,28)
	LastC\LTextA = PeekInt(b1,32)
	LastC\LHandle = PeekInt(b1,0)
	LastC\LText = ""
	For x = 64 To 319
		If PeekByte(b1,x)=0 Then Exit
		LastC\LText = LastC\LText + Chr(PeekByte(b1,x))
	Next
	FreeBank b1
End Function 

Function LV_GetRealColumnIndex(h,c)									
	Return UF__GetRealColumnIndex(h,c)
End Function 


Function LV_AddAllItems#(h,c,g=2)									
	b1 = CreateBank(64)
	UF__AddItemValues(h,c,b1,g)
	For x = 0 To 63
		s$ = s + Chr(PeekByte(b1,x))
	Next
	FreeBank b1
	Return Float(s)
End Function 

Function LV_GetColumnName$(h,c)										
	b1 = CreateBank(256)
	UF__GetColumnName(h,b1,c)
	For x = 0 To 255
		If PeekByte(b1,x)=0Then Exit
		t$=t+Chr(PeekByte(b1,x))
	Next
	FreeBank b1
	Return t
End Function

Function LV_GetIcon(h,l,c=0)										
	Return UF__GetIcon(h,c,l)
End Function 

Function LV_GetEdge(h,c,f=0)										
	b1 = CreateBank(UF__GetLines(h)*4)
	UF__GetItemTextsAsInteger(h,c,b1)
	b2=CreateBank(4):b3=CreateBank(4)
	UF__GetEdgeIntegers(b1,UF__GetLines(h),b2,b3)
	l=PeekInt(b2,0):FreeBank b2:LastC\LX=l
	h=PeekInt(b3,0):FreeBank b3:LastC\LY=h
	FreeBank b1
	If f = 0 Then Return l
	Return h
End Function

;Function LV_GetEdgeFloats#(h,c,f=0)
;	b1 = CreateBank(UF__GetLines(h)*8)
;	UF__GetItemTextsAsFloat(h,c,b1)
;	b2=CreateBank(8):b3=CreateBank(8)
;	UF__GetEdgeIntegers(b1,UF__GetLines(h),b2,b3)
;	l#=PeekFloat(b2,0):FreeBank b2
;	b4 = CreateBank(4)
;	UF__GetFloat(b3,0,b4):FreeBank b3
;	b# = PeekFloat(b4,0)
;	FreeBank b1
;	If f = 0 Then Return l
;	Return b
;End Function




Function LV_SelectLine(h,l,f=1)										
	UF__SelectLine h,l,f
End Function 

Function LV_SetCheckboxState(h,l,z=1)								
	If z=-1 Then z=Not(UF__GetCheckboxState(h,l))
	UF__SetCheckboxState(h,l,z)
End Function 

Function LV_Sort(h,c,d)												
	UF__SortManual(h,c,d)
End Function

Function LV_SetItemText(h,t$,l,c)									
	b1 = CreateBank(Len(t)+1)
	PokeString(t,b1)
	x = UF__SetItemText(h,b1,c,l)
	FreeBank b1
End Function

Function LV_CheckifMarked(h)										
	UF__CheckIfMarked(h)
End Function 

Function LV_MarkIfChecked(h)										
	UF__MarkIfChecked(h)
End Function 

Function LV_SetColumnName(h,c,t$)									
	b1 = CreateBank(256)
	PokeString(t,b1)
	UF__SetColumnName(h,b1,c)
	FreeBank b1
End Function 

Function LV_DeleteAllItems(h)										
	SendMessage (h,4105,0,0)
End Function 

Function LV_DeleteLine(h,l)											
	SendMessage (h,$1008,l,0)
End Function

Function LV_DeleteColumn(h,c)										
	SendMessage (h,$101C,c,0)
End Function 

Function LV_SetColumnWidth(h,i,w)									
	SendMessage (h,4126,i,w)
End Function 

Function LV_CopyLineTo(LV1,LV2,z,z2)								
	UF__CopyLineTo LV1,LV2,z,z2
End Function

Function LV_CopyColumnTo(LV1,LV2,s,s2)								
	UF__CopyColumnTo LV1,LV2,s,s2
End Function 



Function LV_IsPresent(h,t)											
	If t = 0 Then
		Return UF__AreIconsPresent(h)
	End If
	If t = 2 Then
		Return UF__AreCheckboxesPresent(h)
	End If 
End Function

Function MixColors(F1,F2)											
	Return UF__MixRGBs(f1,F2)
End Function 

;################################################################################
;###################### ZUSATZFUNKTIONEN ########################################
;################################################################################

Function PokeString(s$,b)
	For x = 1 To Len(s)
		PokeByte b,x-1,Asc(Mid(s,x,1))
	Next
	PokeByte b,x-1,0
End Function

Function GetFlag(n,f)
	If f => $400 Then f = f - $400:If n = $400 Then Return 1
	If f => $200 Then f = f - $200:If n = $200 Then Return 1
	If f => $100 Then f = f - $100:If n = $100 Then Return 1
	If f => $10 Then f = f - $10:If n = $10 Then Return 1
	If f => $8 Then f = f - $8:If n = $8 Then Return 1
	If f => $4 Then f = f - $4:If n = $4 Then Return 1
	If f => $2 Then f = f - $2:If n = $2 Then Return 1
	If f => $1 Then f = f - $1:If n = $1 Then Return 1
	Return 0
End Function 